package datacatalogapi

// Copyright (c) Microsoft and contributors.  All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//
// See the License for the specific language governing permissions and
// limitations under the License.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"context"
	"github.com/Azure/azure-sdk-for-go/services/datacatalog/mgmt/2016-03-30/datacatalog"
)

// ADCOperationsClientAPI contains the set of methods on the ADCOperationsClient type.
type ADCOperationsClientAPI interface {
	List(ctx context.Context) (result datacatalog.OperationEntityListResult, err error)
}

var _ ADCOperationsClientAPI = (*datacatalog.ADCOperationsClient)(nil)

// ADCCatalogsClientAPI contains the set of methods on the ADCCatalogsClient type.
type ADCCatalogsClientAPI interface {
	CreateOrUpdate(ctx context.Context, resourceGroupName string, properties datacatalog.ADCCatalog) (result datacatalog.ADCCatalog, err error)
	Delete(ctx context.Context, resourceGroupName string) (result datacatalog.ADCCatalogsDeleteFuture, err error)
	Get(ctx context.Context, resourceGroupName string) (result datacatalog.ADCCatalog, err error)
	ListtByResourceGroup(ctx context.Context, resourceGroupName string) (result datacatalog.ADCCatalogsListResult, err error)
	Update(ctx context.Context, resourceGroupName string, properties datacatalog.ADCCatalog) (result datacatalog.ADCCatalog, err error)
}

var _ ADCCatalogsClientAPI = (*datacatalog.ADCCatalogsClient)(nil)
