// Code generated by protoc-gen-go. DO NOT EDIT.
// source: google/cloud/automl/v1beta1/table_spec.proto

package automl

import (
	fmt "fmt"
	math "math"

	proto "github.com/golang/protobuf/proto"
	_ "google.golang.org/genproto/googleapis/api/annotations"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

// A specification of a relational table.
// The table's schema is represented via its child column specs. It is
// pre-populated as part of ImportData by schema inference algorithm, the
// version of which is a required parameter of ImportData InputConfig.
// Note: While working with a table, at times the schema may be
// inconsistent with the data in the table (e.g. string in a FLOAT64 column).
// The consistency validation is done upon creation of a model.
// Used by:
//   *   Tables
type TableSpec struct {
	// Output only. The resource name of the table spec.
	// Form:
	//
	// `projects/{project_id}/locations/{location_id}/datasets/{dataset_id}/tableSpecs/{table_spec_id}`
	Name string `protobuf:"bytes,1,opt,name=name,proto3" json:"name,omitempty"`
	// column_spec_id of the time column. Only used if the parent dataset's
	// ml_use_column_spec_id is not set. Used to split rows into TRAIN, VALIDATE
	// and TEST sets such that oldest rows go to TRAIN set, newest to TEST, and
	// those in between to VALIDATE.
	// Required type: TIMESTAMP.
	// If both this column and ml_use_column are not set, then ML use of all rows
	// will be assigned by AutoML. NOTE: Updates of this field will instantly
	// affect any other users concurrently working with the dataset.
	TimeColumnSpecId string `protobuf:"bytes,2,opt,name=time_column_spec_id,json=timeColumnSpecId,proto3" json:"time_column_spec_id,omitempty"`
	// Output only. The number of rows (i.e. examples) in the table.
	RowCount int64 `protobuf:"varint,3,opt,name=row_count,json=rowCount,proto3" json:"row_count,omitempty"`
	// Output only. The number of columns of the table. That is, the number of
	// child ColumnSpec-s.
	ColumnCount int64 `protobuf:"varint,7,opt,name=column_count,json=columnCount,proto3" json:"column_count,omitempty"`
	// Output only. Input configs via which data currently residing in the table
	// had been imported.
	InputConfigs []*InputConfig `protobuf:"bytes,5,rep,name=input_configs,json=inputConfigs,proto3" json:"input_configs,omitempty"`
	// Used to perform consistent read-modify-write updates. If not set, a blind
	// "overwrite" update happens.
	Etag                 string   `protobuf:"bytes,6,opt,name=etag,proto3" json:"etag,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *TableSpec) Reset()         { *m = TableSpec{} }
func (m *TableSpec) String() string { return proto.CompactTextString(m) }
func (*TableSpec) ProtoMessage()    {}
func (*TableSpec) Descriptor() ([]byte, []int) {
	return fileDescriptor_67819f165062ce17, []int{0}
}

func (m *TableSpec) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_TableSpec.Unmarshal(m, b)
}
func (m *TableSpec) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_TableSpec.Marshal(b, m, deterministic)
}
func (m *TableSpec) XXX_Merge(src proto.Message) {
	xxx_messageInfo_TableSpec.Merge(m, src)
}
func (m *TableSpec) XXX_Size() int {
	return xxx_messageInfo_TableSpec.Size(m)
}
func (m *TableSpec) XXX_DiscardUnknown() {
	xxx_messageInfo_TableSpec.DiscardUnknown(m)
}

var xxx_messageInfo_TableSpec proto.InternalMessageInfo

func (m *TableSpec) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *TableSpec) GetTimeColumnSpecId() string {
	if m != nil {
		return m.TimeColumnSpecId
	}
	return ""
}

func (m *TableSpec) GetRowCount() int64 {
	if m != nil {
		return m.RowCount
	}
	return 0
}

func (m *TableSpec) GetColumnCount() int64 {
	if m != nil {
		return m.ColumnCount
	}
	return 0
}

func (m *TableSpec) GetInputConfigs() []*InputConfig {
	if m != nil {
		return m.InputConfigs
	}
	return nil
}

func (m *TableSpec) GetEtag() string {
	if m != nil {
		return m.Etag
	}
	return ""
}

func init() {
	proto.RegisterType((*TableSpec)(nil), "google.cloud.automl.v1beta1.TableSpec")
}

func init() {
	proto.RegisterFile("google/cloud/automl/v1beta1/table_spec.proto", fileDescriptor_67819f165062ce17)
}

var fileDescriptor_67819f165062ce17 = []byte{
	// 322 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x7c, 0x90, 0x41, 0x4b, 0xc3, 0x30,
	0x14, 0xc7, 0xe9, 0xa6, 0xd3, 0x65, 0x13, 0xa4, 0x5e, 0xca, 0x26, 0x38, 0xc5, 0x43, 0x0f, 0x9a,
	0x30, 0x3d, 0x7a, 0x9a, 0x3d, 0xc8, 0x0e, 0x03, 0x99, 0xe2, 0x41, 0x06, 0x25, 0xcb, 0x62, 0x08,
	0xa4, 0x79, 0xa1, 0x4d, 0xdc, 0x17, 0xf0, 0xd3, 0xf9, 0x6d, 0xfc, 0x06, 0x92, 0xa4, 0xe0, 0x45,
	0x7a, 0x7b, 0xaf, 0xbf, 0xdf, 0xfb, 0x37, 0xef, 0xa1, 0x1b, 0x01, 0x20, 0x14, 0x27, 0x4c, 0x81,
	0xdb, 0x11, 0xea, 0x2c, 0x54, 0x8a, 0x7c, 0xce, 0xb7, 0xdc, 0xd2, 0x39, 0xb1, 0x74, 0xab, 0x78,
	0xd9, 0x18, 0xce, 0xb0, 0xa9, 0xc1, 0x42, 0x3a, 0x8d, 0x36, 0x0e, 0x36, 0x8e, 0x36, 0x6e, 0xed,
	0xc9, 0x75, 0x57, 0x94, 0x84, 0x18, 0x31, 0x39, 0x6f, 0x2d, 0x6a, 0x24, 0xa1, 0x5a, 0x83, 0xa5,
	0x56, 0x82, 0x6e, 0x22, 0xbd, 0xfa, 0x49, 0xd0, 0xf0, 0xd5, 0xff, 0xf5, 0xc5, 0x70, 0x96, 0xa6,
	0xe8, 0x40, 0xd3, 0x8a, 0x67, 0xc9, 0x2c, 0xc9, 0x87, 0xeb, 0x50, 0xa7, 0xb7, 0xe8, 0xcc, 0xca,
	0x8a, 0x97, 0x0c, 0x94, 0xab, 0x74, 0x78, 0x5c, 0x29, 0x77, 0x59, 0x2f, 0x28, 0xa7, 0x1e, 0x15,
	0x81, 0xf8, 0x80, 0xe5, 0x2e, 0x9d, 0xa2, 0x61, 0x0d, 0xfb, 0x92, 0x81, 0xd3, 0x36, 0xeb, 0xcf,
	0x92, 0xbc, 0xbf, 0x3e, 0xae, 0x61, 0x5f, 0xf8, 0x3e, 0xbd, 0x44, 0xe3, 0x36, 0x26, 0xf2, 0xa3,
	0xc0, 0x47, 0xf1, 0x5b, 0x54, 0x56, 0xe8, 0x44, 0x6a, 0xe3, 0x6c, 0xc9, 0x40, 0x7f, 0x48, 0xd1,
	0x64, 0x87, 0xb3, 0x7e, 0x3e, 0xba, 0xcb, 0x71, 0xc7, 0x25, 0xf0, 0xd2, 0x4f, 0x14, 0x61, 0x60,
	0x3d, 0x96, 0x7f, 0x4d, 0xe3, 0x37, 0xe2, 0x96, 0x8a, 0x6c, 0x10, 0x37, 0xf2, 0xf5, 0xe3, 0x57,
	0x82, 0x2e, 0x18, 0x54, 0x5d, 0x89, 0xcf, 0xc9, 0xfb, 0xa2, 0xc5, 0x02, 0x14, 0xd5, 0x02, 0x43,
	0x2d, 0x88, 0xe0, 0x3a, 0x5c, 0x8d, 0x44, 0x44, 0x8d, 0x6c, 0xfe, 0x3d, 0xfe, 0x43, 0x6c, 0xbf,
	0x7b, 0xd3, 0xa7, 0x20, 0x6e, 0x0a, 0x2f, 0x6d, 0x16, 0xce, 0xc2, 0x4a, 0x6d, 0xde, 0xa2, 0xb4,
	0x1d, 0x84, 0xac, 0xfb, 0xdf, 0x00, 0x00, 0x00, 0xff, 0xff, 0x32, 0x47, 0x3a, 0x52, 0x12, 0x02,
	0x00, 0x00,
}
